
import { Node } from "../node-types/abstract-node";

export abstract class EDGE {

    public static readonly EDGE_TYPE: string;
    public static readonly SOURCE_TYPES: string[];
    public static readonly REFERENCE_TYPES: string[];
  
    public readonly source: Node;
    public readonly reference: Node;
  
    public constructor(source: Node, reference: Node) {
        this.source = source;
        this.reference = reference;
    }

    public static nodesCompatible(source: Node, reference: Node): boolean {
        if (!this.SOURCE_TYPES.includes(source.TYPE)) return false;
        if (!this.REFERENCE_TYPES.includes(reference.TYPE)) return false;
        return true;
    }
  
    public static createEdge(source: Node, reference: Node): EDGE {
        throw new Error('You must override the static createEdge method in specific edge implementations');
    }

}