
import { Node } from "./abstract-node";

export class EvidenceNode extends Node{

    public static readonly TYPE = 'evidence';
    public static readonly TYPE_PATTERN = /^\{EVD\}/;

    public constructor(name: string, data: string) {
        super(name, data);
    }

    public static load(fileName: string, fileData: string) {
        const name = fileName.replace(EvidenceNode.TYPE_PATTERN, '')
                    .replace('.md', '')    
                    .trim();
        return new EvidenceNode(name, fileData);
    }

}